﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Schema;

namespace Exemplo_Com_Xml1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btArquivoXML1_Click(object sender, EventArgs e)
        {
            resultado.Text = "";
            try
            {
                XmlReader reader = XmlReader.Create("../../ArquivoXML1.xml");
                // ... Código de Leitura do XML ...
                while (reader.Read())
                {
                    resultado.Text += "* Nome do Elemento:"  + reader.Name + 
                                      " Valor do Elemento: " + reader.Value +
                                      " Tipo do Elemento: "  + reader.NodeType + 
                                      Environment.NewLine + Environment.NewLine;
                }
                // ... Fim do Código de Leitura do XML ...
            }
            catch (XmlException exc)
            {
                MessageBox.Show(exc.Message);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            resultado.Text = "";
            try
            {
                XmlReader reader = XmlReader.Create("../../ArquivoXML1.xml");
                // ... Código de Leitura do XML ...
                while (reader.Read())
                {
                    if ((reader.Name == "nome") && (reader.NodeType.ToString()=="Element"))
                    { 
                        reader.Read(); // Lê o próximo nó
                        resultado.Text += "* " + reader.Value;
                        resultado.Text += Environment.NewLine;
                    }
                }
                // ... Fim do Código de Leitura do XML ...
            }
            catch (XmlException exc)
            {
                MessageBox.Show(exc.Message);
            }
        }

        private static string erro = "";

        private void button2_Click(object sender, EventArgs e)
        {
            resultado.Text = "";
            // Falta: <!ATTLIST filme id CDATA #REQUIRED> em ArquivoXML2.xml
            erro = "";
            XmlReaderSettings settings = new XmlReaderSettings();
            // Configurações do Validador
            settings.ProhibitDtd = false;
            settings.ValidationType = ValidationType.DTD;

            settings.ValidationEventHandler += new ValidationEventHandler(ValidationCallBack);
            XmlReader reader = XmlReader.Create("../../ArquivoXML2.xml", settings);

            while (reader.Read()) ; // Processa o arquivo
            MessageBox.Show(erro);

        }

        private static void ValidationCallBack(object sender, ValidationEventArgs e)
        {
            erro = e.Message;
        }

      
    }
}