﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Schema;
using System.IO;

namespace TestesComXSD
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            erros.Text = "";
            
            // Cria a classe XmlSchemaSet
            XmlSchemaSet sc = new XmlSchemaSet();

            // Adiciona o esquema à coleção
            sc.Add("", "../../mensagem.xsd");

            // Cria as propriedades de validação.
            XmlReaderSettings settings = new XmlReaderSettings();
            // Validar usando esquema
            settings.ValidationType = ValidationType.Schema; 
            // Atribuir o esquema 
            settings.Schemas = sc;
            // Valida warnings também
            settings.ValidationFlags |= XmlSchemaValidationFlags.ReportValidationWarnings;
            // Evento de validação
            settings.ValidationEventHandler += new ValidationEventHandler(ValidationCallBack);

            // Cria o XmlReader
            XmlReader reader = XmlReader.Create("../../mensagem.xml", settings);

            // Faz o parsing do arquivo. 
            while (reader.Read()) ;


        }
        private void ValidationCallBack(object sender, ValidationEventArgs e)
        {
            erros.Text += e.Message + Environment.NewLine;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            erros.Text = "";

            // Cria a classe XmlSchemaSet
            XmlSchemaSet sc = new XmlSchemaSet();

            // Adiciona o esquema à coleção
            sc.Add("", "../../mensagem.xsd");

            // Cria as propriedades de validação.
            XmlReaderSettings settings = new XmlReaderSettings();
            // Validar usando esquema
            settings.ValidationType = ValidationType.Schema;
            // Atribuir o esquema 
            settings.Schemas = sc;
            // Valida warnings também
            settings.ValidationFlags |= XmlSchemaValidationFlags.ReportValidationWarnings;
            // Evento de validação
            settings.ValidationEventHandler += new ValidationEventHandler(ValidationCallBack);

            // Cria o XmlReader
            try
            {
                XmlDocument xml = new XmlDocument();
                System.IO.MemoryStream memXml = new System.IO.MemoryStream();
                xml.LoadXml(docXml.Text);
                xml.Save(memXml);
                memXml.Position = 0;
                XmlReader reader = XmlReader.Create(memXml, settings);


                // Faz o parsing do arquivo. 
                while (reader.Read()) ;

                
               
            }
            catch (Exception exp)
            {
                erros.Text += "Documento XML não está bem formado!" + Environment.NewLine + exp.Message ;
            }
        } 


    }
}