import java.io.*;
import java.net.*;
import java.util.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;

public class EscolaXmlReader {

  // caminho (path) do arquivo XML
  private String xmlPathname;

  // construtor que seta o caminho do XML
  public EscolaXmlReader( String path ) {
    xmlPathname = path;
  }
  
  // le o XML carregando os dados dos usurios em um Vector.
  // retorna o vector contendo os alunos cadastrados no XML.
  public Vector lerAlunos() throws Exception {
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    Document doc = db.parse( xmlPathname );
    Element elem = doc.getDocumentElement();
    // pega todos os elementos do XML
    NodeList nl = elem.getElementsByTagName( "aluno" );
    
    Vector alunos = new Vector();
    
    // percorre cada elemento aluno encontrado
    for( int i=0; i<nl.getLength(); i++ ) 
    {
      Element tagAluno = (Element) nl.item( i );
      
      // pega os dados cadastrado para o aluno atual
      String  nome = getChildTagValue( tagAluno, "nome" );
	  // Obtendo o id de aluno
	  NodeList nlNome = tagAluno.getElementsByTagName( "nome" );
	  int id=0;
	  if(nlNome.getLength()>0)
	  {
	  	  Element tagNome = (Element) nlNome.item( 0 );
	  	  id = Integer.parseInt(  tagNome.getAttribute( "id" ) );
	  }
      Integer idade = new Integer( getChildTagValue( tagAluno, "idade" ) );
      
      // cria uma nova instancia do Aluno com os dados do xml
      Aluno aluno = new Aluno( id, nome, idade);
      
      // adiciona o aluno na coleo de alunos
      alunos.addElement( aluno );
    }
    
    return alunos;
  }
  
  // este mtodo l e retorna o contedo (texto) de uma tag (elemento)
  // filho da tag informada como parmetro. A tag filho a ser pesquisada
  //  a tag informada pelo nome (string)
  private String getChildTagValue( Element elem, String tagName ) throws Exception {
    NodeList children = elem.getElementsByTagName( tagName );
    if( children == null ) return null;
    Element child = (Element) children.item(0);
    if( child == null ) return null;
    return child.getFirstChild().getNodeValue();
  }
}